#ifndef __DXMAIN_H__
#define __DXMAIN_H__

// Header files
#include <ddraw.h>
#include "DXSurface.h"	// Added by ClassView
#include "macros.h"
#include "DXInput.h"	// Added by ClassView

// Class info
class DXMain
{
public:
	DXInput Input;
	int m_ScreenWidth, m_ScreenHeight, m_bpp;
	bool m_Windowed;

	void SpecialBlit( pSurface Source, pSurface Backup, RECT SrcRect, RECT DestRect, USHORT col );
	void ClrScreen();
	bool SetColorKey( pSurface Surf, DWORD Low, DWORD High );
	void Blit( pSurface Src, RECT SrcRct, pSurface Dest, RECT DestRct );
	void Blit( pSurface Src, RECT SrcRct, LPDIRECTDRAWSURFACE7 Dest, RECT DestRct );
	void Blit2Screen( pSurface Src, RECT SrcRct, int x, int y );
	void Blit2Screen( pSurface Src, int x, int y );
	void Blit2Screen2( pSurface Src, pSurface Backup, RECT SrcRct, int x, int y, USHORT col );
	pSurface LoadBitmap( char *Filename, int Mem );
	pSurface LoadPCX( char *Filename, int Mem );
	pSurface LoadTGA( char *Filename, int Mem );
	pSurface CreateSurface( int width, int height, int mem, bool Alpha = false );
	void Flip(void);
	bool DeInitDirectDraw(void);
	DXMain();
	~DXMain();
	bool InitDirectDraw( HWND hWnd, int width = 640, int height = 480, int bpp = 16, bool windowed = false );

private:
	DXSurface Surfs;
	LPDIRECTDRAWSURFACE7 Prim;
	LPDIRECTDRAWSURFACE7 Back;
	LPDIRECTDRAW7 lpDD;
	LPDIRECTDRAWCLIPPER lpClip;
	HWND m_hMainWnd;
	DWORD m_dwClientWidth;
	DWORD m_dwClientHeight;
};

#endif