#ifndef __DXSURFACE_H__
#define __DXSURFACE_H__

#include <ddraw.h>
#include <windows.h>
#include <stdio.h>
#include "macros.h"

#define VideoMemory 1
#define SystemMemory 0

typedef struct _Surface_List
{
	LPDIRECTDRAWSURFACE7 lpDDS;
	int Width;
	int Height;
	HBITMAP Bit;
	char Name[256];
	_Surface_List *Prev;
	_Surface_List *Next;
	bool UsesColorKey;
} Surface, *pSurface;

class DXSurface
{
public:
	pSurface LoadTGA( char *Filename, int mem );
	pSurface LoadPCX( char *Filename, int mem );
	pSurface LoadTGA16( char *Filename, int mem );
	pSurface LoadPCX16( char *Filename, int mem );
	pSurface LoadTGA24( char *Filename, int mem );
	pSurface LoadPCX24( char *Filename, int mem );
	pSurface LoadTGA32( char *Filename, int mem );
	pSurface LoadPCX32( char *Filename, int mem );
	pSurface LoadBitmap( char *Filename, int mem );
	void SetDD( LPDIRECTDRAW7 lpDD );
	void SetBPP( int bpp );
	DXSurface();
	~DXSurface();

	pSurface CreateSurface(int Width, int Height, int Mem, bool Alpha = false);
	bool RemoveSurface(pSurface surf);
	bool RemoveAllSurfaces(void);

private:
	void AddSurface( pSurface temp );
	pSurface SurfList;
	LPDIRECTDRAW7 m_lpDD;
	int m_bpp;
};

#endif