#ifndef __GAME_H__
#define __GAME_H__

#define STATETITLESCREEN 0
#define STATEGAME        1
#define STATEENDGAME     2
#define STATEGAMEWON     3
#define STATEHISCORE     4

#define ISO_NORTH		0
#define ISO_NORTHEAST	1
#define ISO_EAST		2
#define ISO_SOUTHEAST	3
#define ISO_SOUTH		4
#define ISO_SOUTHWEST	5
#define ISO_WEST		6
#define ISO_NORTHWEST	7

#define MM_NONE			0
#define MM_NORTHWEST	1
#define MM_NORTH		2
#define MM_NORTHEAST	3
#define MM_SOUTHWEST	4
#define MM_SOUTH		5
#define MM_SOUTHEAST	6

#define SIZEX 250
#define SIZEY 250

/*
	0	White
	1	Blue
	2	Red
	3	Yellow
	4	Green
	5	Cyan
	6	Purple
*/

#include "DXSurface.h"	// Added by ClassView
#include "DXMain.h"	// Added by ClassView
#include <time.h>
#include <windows.h>

typedef struct _Map_Tile
{
	BYTE  Floor;
	BYTE  Height;
	BYTE  Flags;
	BYTE  Object;
	_Map_Tile *Next;
} MapTile, *pMapTile;

class Game
{
private:
	bool LoadMap( char* Filename );
	void ChangeHeight(int x, int y, int h);
	void Line(int sx, int sy, int ex, int ey);
	bool LoadMouseMaps();
	void MouseMap( int xp, int yp, int &mx, int &my );
	int MM_LookUp( int x, int y, int t );
	void TileWalk( int &x, int &y, int Dir );
	void ClearTestMap();
	void LoadTestMap();
	DWORD CurTime, DeltaTime, LastTime, FpsTime;
	int FramesRendered, Fps;
	int GameState;
	int m_Size;
	pSurface m_Mouse;
	pSurface m_LTiles;
	pSurface m_STiles;
	pSurface m_LMM;
	pSurface m_SMM;
	pSurface m_BigFont;
	pSurface m_SmlFont;
	pSurface m_LObjects;
	pSurface m_SObjects;
	DXMain m_DX;
	MapTile Map[SIZEY][SIZEX];
	BYTE temp[SIZEY+1][SIZEX+1];
	int m_OffX, m_OffY;

public:
	void DrawMouse();
	void DrawLetter(int x, int y, char Ltr);
	void DrawBigLetter(int x, int y, char Ltr);
	void DrawString( int Size, char *Text, int x, int y );
	void CheckKeyInput( void );
	void RenderTitleScreen( void );
	void RenderGameOver( void );
	void RenderHiScore( void );
	void Render();
	void DeInit(void);
	void GameLoop(void);
	bool Init( HWND hWnd, HINSTANCE hInst );
};

extern HWND ghWnd;

extern char g_MouseMap[2][20][64][32];

#endif